<?php

/**
 * Gpealtesitufunc
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     SetForms Team <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Gpealtesitufunc extends DaoGpeAltesitufunc
{

    public static function getSituacoesVinculo($nrorg, $nrvinculom) {
        $altesitufuncs = self::getObjectsByWhere('NRORG = ? AND NRVINCULOM = ?', array($nrorg, $nrvinculom));
        return $altesitufuncs;
    }

    /**
     * @param $nrorg
     * @param $nrvinculom
     * @param $dtinisitufunc
     * @return \GpealtesitufuncEntity
     */
    public static function getUltimaSituacaoPorDatainicio($nrorg, $nrvinculom, $dtinisitufunc) {

        $db = \Setforms2\Runtime\Connection::getInstance();

        $params = array($nrorg, $nrvinculom, $dtinisitufunc);

        $sql = <<<SQL

SELECT *
  FROM GPE_ALTESITUFUNC
WHERE NRORG         = ?
  AND NRVINCULOM    = ?
  AND DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                         FROM GPE_ALTESITUFUNC B
                       WHERE B.NRORG       = GPE_ALTESITUFUNC.NRORG
                         AND B.NRVINCULOM  = GPE_ALTESITUFUNC.NRVINCULOM
                         AND DTINISITUFUNC <= TO_DATE(?, 'DD/MM/YYYY'))

SQL;
        $resultado = $db->fetchAll($sql, $params);
        $objResult = reset(self::createObjectsFromArray($resultado));
        return $objResult;

    }

    /**
     * Retorna lista de Objetos Gpealtesitufunc.
     *
     * @param integer $nr_vinculo N�mero do V�nculo.
     * @param integer $nr_org     N�mero da Organiza��o.
     *
     * @return array Gpealtesitufunc
     */
    public static function retornaItem($nr_vinculo, $nr_org){
        return self::getObjectsByWhere(
            'NRVINCULOM = ?
             AND NRORG = ?',
            array(
             $nr_vinculo, $nr_org,
            ),'DTINISITUFUNC'
        );
    }

    /**
     * Retorna Objeto Gpealtesitufunc.
     *
     * @param integer $nr_vinculo   Numero do Vinculo.
     * @param integer $nr_situacao  Numero da Situacao Funcional.
     * @param integer $nr_cid       Numero do CID.
     * @param integer $nr_org       Numero da Organizacaoo.
     *
     * @return Gpealtesitufunc
     *
     * @author brunoborba 10/02/2015 Para atender a solicitação 154336
     */
    public static function retornaAlteSitFuncporVinculoNrcid($nr_vinculo,$nr_situacao,$nr_cid,$nr_org){
        return self::getObjectsByWhere(
            'NRVINCULOM = ?
             AND NRSITUFUNCM = ?
             AND CDTABECDI = ?
             AND NRORG = ?',
            array(
                $nr_vinculo,$nr_situacao,$nr_cid, $nr_org,
            ),'DTINISITUFUNC DESC'
        );
    }

    /**
     * Retorna Objeto Gpealtesitufunc.
     *
     * @param integer $nr_vinculo   Numero do Vinculo.
     * @param integer $nr_situacao  Numero da Situacao Funcional.
     * @param integer $nr_org       Numero da Organizacaoo.
     *
     * @return Gpealtesitufunc
     *
     * @author brunoborba 27/11/2014 Para atender a solicitação 153873
     */
    public static function retornaAlteSitFuncporVinculoNrsituacao($nr_vinculo,$nr_situacao,$nr_org){
        return self::getObjectsByWhere(
            'NRVINCULOM = ?
             AND NRSITUFUNCM = ?
             AND NRORG = ?',
            array(
                $nr_vinculo,$nr_situacao, $nr_org,
            ),'DTINISITUFUNC DESC'
        );
    }

    /**
     *
     */
    public function preInsert($event)
    {
        parent::preInsert($event);
        $strategy_0 = new GeraNrOrgOperadorStrategy("@Geral\Util\Ambiente::getNrorg()@");
        $strategy_0->setColumnName("NRORGINCLUSAO");
        $table = "GPE_ALTESITUFUNC";
        $strategy_0->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_0->setTableName($table);
        $strategy_0->setData($this->getDataAsArray());
        $strategy_0->setPkColumns($pkColumns);
        $strategy_0->setColumns($columnMapper);
        $strategy_0->setStep(0);
        $this->NRORGINCLUSAO = $strategy_0->execute();
        $strategy_1 = new GeraDataStrategy("@Ambiente::getCdOperador()@");
        $strategy_1->setColumnName("CDOPERINCLUSAO");
        $table = "GPE_ALTESITUFUNC";
        $strategy_1->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_1->setTableName($table);
        $strategy_1->setData($this->getDataAsArray());
        $strategy_1->setPkColumns($pkColumns);
        $strategy_1->setColumns($columnMapper);
        $strategy_1->setStep(0);
        $this->CDOPERINCLUSAO = $strategy_1->execute();
        $strategy_4 = new GeraDataStrategy("@now()@");
        $strategy_4->setColumnName("DTINCLUSAO");
        $table = "GPE_ALTESITUFUNC";
        $strategy_4->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_4->setTableName($table);
        $strategy_4->setData($this->getDataAsArray());
        $strategy_4->setPkColumns($pkColumns);
        $strategy_4->setColumns($columnMapper);
        $strategy_4->setStep(0);
        $this->DTINCLUSAO = $strategy_4->execute();
        $strategy_5 = new GeraDataStrategy("@now()@");
        $strategy_5->setColumnName("DTULTATU");
        $table = "GPE_ALTESITUFUNC";
        $strategy_5->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_5->setTableName($table);
        $strategy_5->setData($this->getDataAsArray());
        $strategy_5->setPkColumns($pkColumns);
        $strategy_5->setColumns($columnMapper);
        $strategy_5->setStep(0);
        $this->DTULTATU = $strategy_5->execute();
        $strategy_6 = new GeraIdStrategy("NRORG = @\Geral\Util\Ambiente::getNrorgTrabalho()@");
        $strategy_6->setColumnName("NRALTESITUFUNC");
        $table = "GPE_ALTESITUFUNC";
        $strategy_6->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_6->setTableName($table);
        $strategy_6->setData($this->getDataAsArray());
        $strategy_6->setPkColumns($pkColumns);
        $strategy_6->setColumns($columnMapper);
        $strategy_6->setStep(1);
        $this->NRALTESITUFUNC = $strategy_6->execute();
    }

    /**
     *
     */
    public function preUpdate($event)
    {
        parent::preUpdate($event);
        $strategy_2 = new GeraNrOrgOperadorStrategy("@Geral\Util\Ambiente::getNrorg()@");
        $strategy_2->setColumnName("NRORGULTATU");
        $table = "GPE_ALTESITUFUNC";
        $strategy_2->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_2->setTableName($table);
        $strategy_2->setData($this->getDataAsArray());
        $strategy_2->setPkColumns($pkColumns);
        $strategy_2->setColumns($columnMapper);
        $strategy_2->setStep(0);
        $this->NRORGULTATU = $strategy_2->execute();
        $strategy_3 = new GeraDataStrategy("@Ambiente::getCdOperador()@");
        $strategy_3->setColumnName("CDOPERULTATU");
        $table = "GPE_ALTESITUFUNC";
        $strategy_3->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_3->setTableName($table);
        $strategy_3->setData($this->getDataAsArray());
        $strategy_3->setPkColumns($pkColumns);
        $strategy_3->setColumns($columnMapper);
        $strategy_3->setStep(0);
        $this->CDOPERULTATU = $strategy_3->execute();
        $strategy_5 = new GeraDataStrategy("@now()@");
        $strategy_5->setColumnName("DTULTATU");
        $table = "GPE_ALTESITUFUNC";
        $strategy_5->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_5->setTableName($table);
        $strategy_5->setData($this->getDataAsArray());
        $strategy_5->setPkColumns($pkColumns);
        $strategy_5->setColumns($columnMapper);
        $strategy_5->setStep(0);
        $this->DTULTATU = $strategy_5->execute();
    }

}