<?php

namespace Teknisa\Model\Geral\Repositories;


class Parcnegocio extends \Doctrine\ORM\EntityRepository {



    public function findBilletIssuedFct($nrlanctonf){
        $query = <<<SQL
            SELECT CDFILIAL, NRLANBOLREC,CDREDUCONT
          FROM (SELECT C.CDFILIAL,BO.NRLANBOLREC,BO.CDREDUCONT
                  FROM CONTARECEBER C
                  JOIN NOTAFISCAL N ON (N.NRLANCTONF = C.NRLANCTONF AND N.CDFILIAL = C.CDFILIAL AND N.NRORG = C.NRORG )
                  JOIN CLIENTE CLI ON (N.CDCLIENTE = CLI.CDCLIENTE AND N.NRORG = CLI.NRORG)
                  JOIN BOLETRECEBER BO ON (BO.NRLANBOLREC = C.NRLANBOLREC AND BO.CDFILIAL = C.CDFILIAL)
                  JOIN FCT_APURACAO APU ON APU.NRLANCTONF = N.NRLANCTONF AND APU.CDFILIAL = N.CDFILIAL
             WHERE APU.NRLANCTONF = :NRLANCTONF)

             GROUP BY CDFILIAL, NRLANBOLREC, CDREDUCONT

SQL;

        $params = array(
            "NRLANCTONF" => $nrlanctonf
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    /**
     * @param $filter
     * @param $dtinicompetFilter
     * @param $dtfincompetFilter
     * @param $nrorg
     * @param $nrparcnegocio
     * @return array
     */
    public function getFaturamentoContrato($filter, $dtinicompetFilter, $dtfincompetFilter, $dtinicompetFilterMed, $dtfincompetFilterMed, $nrorg, $nrparcnegocio, $limit = 500, $offset = 1, $orderString)
    {
        $query =
            <<<SQL
             SELECT *
           FROM (

        SELECT DISTINCT
           DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS TIPO,
           AGRUPCONT.IDPARCAGRUP,
           TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
           DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT,  AGRUPA.NMAGRUPAMENTO) AS NRCONTRATOFCT,
           CASE AGRUPCONT.IDPARCAGRUP WHEN 'N'
                THEN TO_CHAR(CONT.NRSEQCONTRATO)
                ELSE (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP( ORDER BY NRSEQCONTRATO)
                        FROM FCT_RELACAGRUPCONTFAT
                       WHERE NRFATURACONT = FAT.NRFATURACONT)
            END AS NRSEQCONTRATO,
           DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT,
           DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS IDTIPO,
           FAT.NRGRUPOFATURA,
           FAT.CDFILIALFATURA,
           FILIFAT.NMFILIAL AS NMFILIALFATURA,
           FAT.NRPARCFATURA,
           PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA,
           FAT.IDTPFATURA,
           CASE
               WHEN FIN.IDSTATREC = 'B' THEN 'RECEBIDO'
               WHEN FIN.IDSTATREC = 'P'  THEN 'PLANEJADO'
               WHEN TRUNC(FIN.DTATUAVENREC) < TRUNC(SYSDATE) THEN 'ATRASO'
               ELSE 'FATURADA'
           END AS IDSITUACAO,
           DECODE(FAT.NRFATURACONT, NULL, TRUNC(FIN.DTEMISSAO, 'mm'), FAT.DTINICOMPET) AS DTINICOMPET,
           DECODE(FAT.NRFATURACONT, NULL, LAST_DAY(FIN.DTEMISSAO), FAT.DTFINCOMPET) AS DTFINCOMPET,
           FAT.DTLIMITEAPU,
           DECODE(FIN.NRNOTAFISC, NULL, NULL, FIN.DTATUAVENREC) AS DTVENCIMENTO,
           FAT.NRDIASVENCIMENTO,
           FAT.QTDIASFATUVENC,
           NVL(NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO), (SUM(FIN.VRLIQUIDBOL) OVER (PARTITION BY FIN.CDFILIAL, FIN.NRLANCTONF, AGRUPCONT.NRAGRUPCONTFAT))) AS VRVENCIMENTO,
           NVL(FAT.VRVENCIMENTO, (SUM(FIN.VRLIQUIDBOL) OVER (PARTITION BY FIN.CDFILIAL, FIN.NRLANCTONF, AGRUPCONT.NRAGRUPCONTFAT))) AS VRORIGINAL,
           FAT.VRFATURADO,
           FAT.VRFALTAFATURAR,
           FAT.IDFORMAFATURA,
           FAT.IDALTUSUARIO,
           FAT.NRAPURACAO,
           FIN.NRLANCTONF,
           FIN.CDFILIAL AS CDFILIALNF,
           FILINF.NMFILIAL AS NMFILIALNF,
           FIN.NRNOTAFISC,
           FIN.DTENTRSAID,
           FAT.IDATIVO,
           FAT.NRORG,
           FAT.DTINCLUSAO,
           FAT.NRORGINCLUSAO,
           FAT.CDOPERINCLUSAO,
           FAT.DTULTATU,
           FAT.NRORGULTATU,
           FAT.CDOPERULTATU,
           DECODE(AGRUPCONT.IDPARCAGRUP, 'S', AGRUPA.DSOBSAGRUPAMENTO, CONT.DSREFERENCIACONT) DSREFERENCIACONT,
           FIN.VRNOTAFISC,
           DECODE(FIN.NRNOTAFISC, NULL, NULL, FIN.VRATUAREC) AS VRATUAREC,
           RELAGRUPCONT.NRAGRUPAMENTO,
           FAT.VRNEGCONTR,
          DECODE(AGRUPCONT.IDPARCAGRUP, 'N', ORC.NRORCAMENTO, AGRUPA.NMAGRUPAMENTO) AS NRORCAMENTO,
          NVL(DECODE(AGRUPCONT.IDPARCAGRUP, 'N', ORC.NRORCAMENTO, AGRUPA.NMAGRUPAMENTO),  DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, AGRUPA.NMAGRUPAMENTO)) AS NRPROPOSTA
                        
          FROM (SELECT BO.IDSTATBREC, CL.NRPARCNEGOCIO, NF.DTEMISSAO, NF.DTENTRSAID,
                       NRNOTAFISC,
                       NF.CDSERIE,
                       CL.NRINSJURCLIE,
                       CL.NMRAZSOCCLIE,
                       NF.VRPRODUTOS,
                       NF.VRNOTAFISC,
                       NVL(IM.VRRETENCAO,0) AS VRRETIDO,
                       CR.VRORIGREC ,
                      (CR.VRATUAREC - CR.VRORIGREC) AS VRAJUSTECONTA,
                       ROUND(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC)))) - (CR.VRATUAREC ),2) AS VRAJUSTEBOL,
                       ROUND(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC)))),2) AS VRLIQUIDBOL,
                       CR.VRATUAREC,
                       CR.NRPARCELAREC,
                       CR.DSCONTAREC,
                       CR.DTORIGVENREC,
                       CR.DTATUAVENREC,
                       BR.DTBAIXAREC,
                       BO.IDSTATBREC AS IDSTATREC,
                       DECODE(BO.IDSTATBREC, 'P','PLANEJADO', 'A', 'EM ABERTO', 'E', 'EMITIDO', 'B', 'BAIXADO')  AS STATUS,
                       COUNT(*) OVER(PARTITION BY NF.CDFILIAL,NF.NRLANCTONF) AS QUANT,
                       E.NMEMPRESA,
                       E.NRINSJUREMPR,
                       NF.NRORG,
                       NF.CDFILIAL,
                       NF.NRLANCTONF,
                       CASE WHEN (CR.DTATUAVENREC < TRUNC(SYSDATE)) AND (BO.IDSTATBREC IN ('A','E'))
                            THEN 'V'
                            WHEN (CR.DTATUAVENREC >= TRUNC(SYSDATE)) AND (BO.IDSTATBREC IN ('A','E'))
                            THEN 'P'
                            ELSE 'E'
                        END AS VALIDATOR
                  FROM NOTAFISCAL NF, CONTARECEBER CR, BOLETRECEBER BO, CLIENTE CL, EMPRESA E, BAIXARECEBIDA BR,
                       (SELECT SUM(VRIMPOSTONF) AS VRRETENCAO, CDFILIAL, NRLANCTONF
                          FROM IMPOSTONF I, IMPOSTO II
                         WHERE I.CDIMPOSTO = II.CDIMPOSTO
                           AND II.IDTRATIMPO = 'R'
                         GROUP BY CDFILIAL, NRLANCTONF) IM
                 WHERE NF.CDCLIENTE = CL.CDCLIENTE
                   AND CL.NRPARCNEGOCIO = :NRPARCNEGOCIO
                   AND NF.CDFILIAL = CR.CDFILIAL
                   AND NF.NRLANCTONF = CR.NRLANCTONF
                   AND CR.CDFILIBOLREC = BO.CDFILIAL
                   AND CR.NRLANBOLREC = BO.NRLANBOLREC
                   AND BO.CDFILIBAIREC = BR.CDFILIAL(+)
                   AND BO.NRBAIXAREC  = BR.NRBAIXAREC(+)
                   AND IM.CDFILIAL(+) = NF.CDFILIAL
                   AND IM.NRLANCTONF(+) = NF.NRLANCTONF
                   AND E.CDEMPRESA      = NF.CDEMPRESA) FIN
          LEFT JOIN FCT_APURACAO APU
                 ON APU.CDFILIAL = FIN.CDFILIAL
                AND APU.NRLANCTONF = FIN.NRLANCTONF
          LEFT JOIN FCT_RELACAPURACAOFATURA REL
                 ON REL.NRAPURACAO = APU.NRAPURACAO
          LEFT JOIN FCT_FATURACONT FAT
                 ON FAT.NRFATURACONT = REL.NRFATURACONT
          LEFT JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                 ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
                AND FAT.NRORG = AGRUPCONT.NRORG
          LEFT JOIN FCT_CONTRATO CONT
                 ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND AGRUPCONT.NRORG = CONT.NRORG
          LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGRUPCONT
                 ON RELAGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND RELAGRUPCONT.NRORG = CONT.NRORG
          LEFT JOIN FCT_AGRUPAMENTO AGRUPA
                 ON AGRUPA.NRAGRUPAMENTO = RELAGRUPCONT.NRAGRUPAMENTO
                AND AGRUPA.NRORG = RELAGRUPCONT.NRORG
          LEFT JOIN FILIAL FILIFAT
                 ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
                AND FAT.NRORG          = FILIFAT.NRORG
         INNER JOIN PARCNEGOCIO PARCFAT
                 ON PARCFAT.NRPARCNEGOCIO = FIN.NRPARCNEGOCIO
                AND PARCFAT.NRORG = FIN.NRORG
          LEFT JOIN FILIAL FILINF
                 ON FILINF.CDFILIAL = FIN.CDFILIAL
          LEFT JOIN FCT_REFEORCACONT REFORC
				 ON REFORC.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		  LEFT JOIN FCT_ORCAMENTO ORC
		         ON ORC.NRSEQORCAMENTO = REFORC.NRSEQORCAMENTO
              $dtinicompetFilter
              $dtfincompetFilter

         UNION ALL

        SELECT DISTINCT DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS TIPO, AGRUPCONT.IDPARCAGRUP, TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
                        DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, AGRUPA.NMAGRUPAMENTO) AS NRCONTRATOFCT,
                        CASE AGRUPCONT.IDPARCAGRUP
                             WHEN 'N'
                             THEN TO_CHAR(CONT.NRSEQCONTRATO)
                             ELSE (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP( ORDER BY NRSEQCONTRATO)
                                     FROM FCT_RELACAGRUPCONTFAT
                                    WHERE NRFATURACONT = FAT.NRFATURACONT)
                         END AS NRSEQCONTRATO,
                        DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT,
                        DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS IDTIPO,
                        FAT.NRGRUPOFATURA, FAT.CDFILIALFATURA, FILIFAT.NMFILIAL AS NMFILIALFATURA,
                        FAT.NRPARCFATURA, PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA, FAT.IDTPFATURA,
                        'PENDENTE' AS IDSITUACAO,
                        FAT.DTINICOMPET, FAT.DTFINCOMPET,
                        FAT.DTLIMITEAPU, NULL AS DTVENCIMENTO, FAT.NRDIASVENCIMENTO, FAT.QTDIASFATUVENC, NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO) AS VRVENCIMENTO, FAT.VRVENCIMENTO AS VRORIGINAL,
                        FAT.VRFATURADO, FAT.VRFALTAFATURAR, FAT.IDFORMAFATURA, FAT.IDALTUSUARIO, FAT.NRAPURACAO, NF.NRLANCTONF,
                        NF.CDFILIAL AS CDFILIALNF, FILINF.NMFILIAL AS NMFILIALNF, NF.NRNOTAFISC, NF.DTENTRSAID, FAT.IDATIVO,
                        FAT.NRORG, FAT.DTINCLUSAO, FAT.NRORGINCLUSAO, FAT.CDOPERINCLUSAO, FAT.DTULTATU, FAT.NRORGULTATU,
                        FAT.CDOPERULTATU,
                        DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.DSREFERENCIACONT, AGRUPA.DSOBSAGRUPAMENTO) DSREFERENCIACONT,
                        NF.VRNOTAFISC,
                        NULL AS VRATUAREC,
                        RELAGRUPCONT.NRAGRUPAMENTO,
                        FAT.VRNEGCONTR,
                         DECODE(AGRUPCONT.IDPARCAGRUP, 'N', ORC.NRORCAMENTO, AGRUPA.NMAGRUPAMENTO) AS NRORCAMENTO,
                         NVL(DECODE(AGRUPCONT.IDPARCAGRUP, 'N', ORC.NRORCAMENTO, AGRUPA.NMAGRUPAMENTO),  DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, AGRUPA.NMAGRUPAMENTO)) AS NRPROPOSTA
                        
          FROM FCT_FATURACONT FAT
         INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                 ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
                AND FAT.NRORG        = AGRUPCONT.NRORG
          LEFT JOIN FCT_CONTRATO CONT
                 ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND AGRUPCONT.NRORG         = CONT.NRORG
          LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGRUPCONT
                 ON RELAGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                AND RELAGRUPCONT.NRORG         = CONT.NRORG
          LEFT JOIN FCT_AGRUPAMENTO AGRUPA
                 ON AGRUPA.NRAGRUPAMENTO = RELAGRUPCONT.NRAGRUPAMENTO
                AND AGRUPA.NRORG         = RELAGRUPCONT.NRORG
         INNER JOIN FILIAL FILIFAT
                 ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
                AND FAT.NRORG          = FILIFAT.NRORG
         INNER JOIN PARCNEGOCIO PARCFAT
                 ON FAT.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
                AND FAT.NRORG = PARCFAT.NRORG
          LEFT JOIN (SELECT APURFAT.NRFATURACONT, LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP( ORDER BY NF.NRLANCTONF ) AS NRLANCTONF,
                            NF.CDFILIAL, LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP( ORDER BY NF.NRNOTAFISC ) AS NRNOTAFISC,
                            NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC
                       FROM FCT_RELACAPURACAOFATURA APURFAT
                      INNER JOIN FCT_APURACAO APU
                              ON APURFAT.NRAPURACAO = APU.NRAPURACAO
                             AND APURFAT.NRORG      = APU.NRORG
                       LEFT JOIN NOTAFISCAL NF
                              ON APU.NRLANCTONF = NF.NRLANCTONF
                             AND APU.CDFILIAL   = NF.CDFILIAL
                      GROUP BY NF.CDFILIAL, APURFAT.NRFATURACONT, NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC) NF
                 ON FAT.NRFATURACONT = NF.NRFATURACONT
                AND FAT.NRORG = NF.NRORG
          LEFT JOIN FILIAL FILINF
                 ON NF.CDFILIAL = FILINF.CDFILIAL
          LEFT JOIN FCT_REFEORCACONT REFORC
				 ON REFORC.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		  LEFT JOIN FCT_ORCAMENTO ORC
		         ON ORC.NRSEQORCAMENTO = REFORC.NRSEQORCAMENTO
         WHERE FAT.NRORG        = :NRORG
           AND FAT.NRPARCFATURA = :NRPARCNEGOCIO
           AND FAT.DTINICOMPET > LAST_DAY(ADD_MONTHS(TRUNC(SYSDATE), -2))
           AND CONT.IDATIVO     = 'S'
           AND FAT.IDSITUACAO IN ('1', '2', '6')

         UNION ALL

        SELECT NVL2(MED.NRAGRUPAMENTO, 'AME', 'M') AS TIPO,
               NULL AS IDPARCAGRUP,
               NULL AS DSJUSTIFICATIVA,
               MED.NRCONTRATOFCT,
               MED.NRSEQCONTRATO,
               NVL2(MED.NRAGRUPAMENTO, NULL, 'M') || MED.NRMEDICAOFATURA AS NRFATURACONT,
               NVL2(MED.NRAGRUPAMENTO, 'AME', 'M') AS IDTIPO,
               MED.NRGRUPOFATURA,
               MED.CDFILIALFATURA,
               MED.NMFILIALFATURA,
               MED.NRPARCFATURA,
               MED.NMPARCFATURA,
               MED.IDTPFATURA,
               'ESTIMADO' AS IDSITUACAO,
               MED.DTINICOMPET,
               MED.DTFINCOMPET,
               MED.DTLIMITEAPU,
               NULL AS DTVENCIMENTO,
               MED.NRDIASVENCIMENTO,
               MED.QTDIASFATUVENC,
               NVL(MED.VRNEGCONTR, MED.PRECOMEDICAO) AS VRVENCIMENTO,
               MED.PRECOMEDICAO AS VRORIGINAL,
               0 AS VRFATURADO,
               NVL(MED.VRNEGCONTR, MED.PRECOMEDICAO) AS VRFALTAFATURAR,
               NULL AS IDFORMAFATURA,
               NULL AS IDALTUSUARIO,
               NULL AS NRAPURACAO,
               NULL AS NRLANCTONF,
               NULL AS CDFILIALNF,
               NULL AS NMFILIALNF,
               NULL AS NRNOTAFISC,
               NULL AS DTENTRSAID,
               MED.IDATIVO,
               MED.NRORG,
               MED.DTINCLUSAO,
               MED.NRORGINCLUSAO,
               MED.CDOPERINCLUSAO,
               MED.DTULTATU,
               MED.NRORGULTATU,
               MED.CDOPERULTATU,
               MED.DSREFERENCIACONT,
               NULL AS VRNOTAFISC,
               NULL AS VRATUAREC,
               MED.NRAGRUPAMENTO,
               MED.VRNEGCONTR,
               ORC.NRORCAMENTO,
               NVL(NRORCAMENTO,MED.NRCONTRATOFCT) AS NRPROPOSTA
          FROM TABLE(FCT_BUSCA_PRECOMEDICAO(:NRPARCNEGOCIO, :NRORG)) MED
          LEFT JOIN FCT_REFEORCACONT REFORC
				 ON REFORC.NRSEQCONTRATO = DECODE(LENGTH(TRIM(TRANSLATE(MED.NRSEQCONTRATO, '0123456789',' '))) ,NULL,MED.NRSEQCONTRATO)
		  LEFT JOIN FCT_ORCAMENTO ORC
		         ON ORC.NRSEQORCAMENTO = REFORC.NRSEQORCAMENTO
         WHERE MED.DTINICOMPET > LAST_DAY(ADD_MONTHS(TRUNC(SYSDATE), -2))

              $dtinicompetFilterMed
               $dtfincompetFilterMed
        )

        WHERE 1 = 1

              $filter
            $orderString
SQL;

        $params = array(
            "NRORG" => $nrorg,
            "NRPARCNEGOCIO" => $nrparcnegocio
        );

        $query = $this->getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    private function getPaginatedQuery($query, $limit, $offset) {
        if ($limit > 0) {
            $max = $offset + $limit;
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $max . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $max;
            }
        }
        return $query;
    }
}
